----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    17:26:45 11/28/2007 
-- Design Name: 
-- Module Name:    pulse_gen - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity pulse_gen is
    Port ( 
			  CLK_in : in  STD_LOGIC; 
           RST_in : in  STD_LOGIC;
           Pulse_out : out  STD_LOGIC
			);
end pulse_gen;

architecture Behavioral of pulse_gen is
	signal q		 :	STD_LOGIC_VECTOR(15 downto 0);
begin

	process (CLK_in)
	begin
		if (rising_edge(CLK_in)) then
			if (RST_in = '1') then
				q	<= conv_std_logic_vector(20833,16);
			else
				if (q	= conv_std_logic_vector(41666,16)) then
					q	<= (others => '0');
				else
					q	<= q + 1;
				end if;
			end if;		
		end if;	
	end process;
	
	Pulse_out	<= '1' when	q = conv_std_logic_vector(41666,16) else '0';	

end Behavioral;

