----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    13:01:02 12/14/2007 
-- Design Name: 
-- Module Name:    shift_reg - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity shift_reg is
	PORT(
		CLK_in		: IN std_logic;
		RST_in		: IN std_logic;
		SE_in			: IN std_logic;
		VALUE_in		: IN std_logic;
		VALUE_out	: OUT std_logic_vector(7 downto 0)	
	);


end shift_reg;

architecture Behavioral of shift_reg is
	signal q	: std_logic_vector(7 downto 0);
begin

	VALUE_out <= q;

	process (CLK_in)
	begin
		if (rising_edge(CLK_in)) then
			if (RST_in = '1') then
				q	<= (others => '1');
			elsif (SE_in = '1') then
				q <= VALUE_in & q(7 downto 1) ;
			end if;
		end if;	
	end process;
	
end Behavioral;

